VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4335
   ClientLeft      =   120
   ClientTop       =   420
   ClientWidth     =   7170
   LinkTopic       =   "Form1"
   ScaleHeight     =   289
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   478
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton Command1 
      Caption         =   "Clear"
      Height          =   375
      Left            =   120
      TabIndex        =   3
      Top             =   960
      Width           =   1095
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Left            =   2160
      Top             =   360
   End
   Begin VB.PictureBox Room 
      BackColor       =   &H00FFFFFF&
      FillStyle       =   0  'Ausgefllt
      Height          =   2775
      Left            =   2040
      ScaleHeight     =   181
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   205
      TabIndex        =   0
      Top             =   1440
      Width           =   3135
   End
   Begin VB.Label Label2 
      Caption         =   "Label2"
      Height          =   255
      Left            =   0
      TabIndex        =   2
      Top             =   360
      Width           =   1215
   End
   Begin VB.Label Label1 
      Caption         =   "Label1"
      Height          =   255
      Left            =   0
      TabIndex        =   1
      Top             =   0
      Width           =   1215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'AntisocialRobots
'zur Vernetzung
Private Const ROOM_SIZE   As Long = 200
Private m_roomCells() As Robot
Private m_robots      As ListOfRobot
Private m_nextColor   As Color
'Dim m_framesPerSecondStopwatch As Stopwatch
Private m_frameIndex  As Long
Const FramesPerSample As Long = 10

Private Sub Command1_Click()
    Timer1.Enabled = Not Timer1.Enabled
    If Not Timer1.Enabled Then
        ListOfRobot_Clear m_robots
        Call clearState
    End If
    Command1.Caption = IIf(Timer1.Enabled, "Clear", "Start")
End Sub

Private Sub Form_Initialize()
    clearState
End Sub
'// Initializes robot state
Sub clearState()
    ReDim m_roomCells(0 To ROOM_SIZE - 1, 0 To ROOM_SIZE - 1)
    Room.Refresh
    m_nextColor = ColorRGB(240, 10, 0)
End Sub
Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    If KeyCode = vbKeyF5 Then
        Call clearState
    End If
End Sub
Private Sub Form_Load()
    'recomputeAndRedraw
    Timer1.Interval = 1 '0
    Timer1.Enabled = True
    'Dim X As Double: X = 1
    'Dim Y As Double: Y = -1
    'Dim a As Double: a = Math.Atan2(Y, X)
    'MsgBox a
    
End Sub
Private Sub recomputeAndRedraw()
    PerformSimulationStep
    Room.Refresh
    'recomputeAndRedraw 'really?
    '
End Sub

Private Sub Room_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    If Button = vbLeftButton Then
        If 0 <= x And x < 1 And 0 <= y And y < 1 Then _
            Call CreateRobot(MousePositionToRoomPoint(x, y))
    End If
End Sub

Private Sub Room_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim Rpt As RoomPoint: Rpt = MousePositionToRoomPoint(x, y)
    Label2.Caption = RoomPoint_ToString(Rpt)
    If Button = vbLeftButton Then
        If 0 <= x And x < 1 And 0 <= y And y < 1 Then _
            Call CreateRobot(Rpt)
    End If
End Sub

Private Sub Form_Resize()
    Dim size As Double: size = MinDbl(Me.ScaleWidth, Me.ScaleHeight)
    Dim marginX As Double: marginX = (Me.ScaleWidth - size) / 2
    Dim marginY As Double: marginY = (Me.ScaleHeight - size) / 2
    Room.Left = marginX
    Room.Top = marginY
    Room.Width = size
    Room.Height = size
    Room.Scale (0, 0)-(1, 1)
End Sub

Private Sub CreateRobot(pt As RoomPoint)
    '// Do nothing if there's already a robot here
    If Not MRobot.IsEqual(m_roomCells(pt.x, pt.y), NullRobot) Then Exit Sub
    
    '// Create the new robot
    Dim rob As Robot: rob = New_Robot _
    ( _
        pt, _
        New_Ellipse _
        ( _
            1# / ROOM_SIZE, _
            1# / ROOM_SIZE, _
            m_nextColor _
        ) _
    )
    
'        Element = new Ellipse()
'        {
'            Width = 1.0 / ROOM_SIZE,
'            Height = 1.0 / ROOM_SIZE,
'            HorizontalAlignment = HorizontalAlignment.Left,
'            VerticalAlignment = VerticalAlignment.Top,
'            Fill = new SolidColorBrush(_nextColor)
'        }
'    }

    '// Set the position of the robot within Room
    Call SetRobotElementPosition(rob, pt)

    '// Add the robot to Room
    'Call Room.Children.Add(rob.Element)
    '// Add the robot to our data structures
    Call MRobot.ListOfRobot_Add(m_robots, rob)
    
    m_roomCells(pt.x, pt.y) = rob

    '// Advance _nextColor to the next color to use
    MoveNextColor
    
    Room.Refresh
    Label1.Caption = CStr(m_robots.Count)
End Sub

Private Sub MoveNextColor()
    If (m_nextColor.B = 0) Then
        m_nextColor.r = CByte(MaxLng(CLng(m_nextColor.r) - 10, 0))
        m_nextColor.G = CByte(MaxLng(CLng(m_nextColor.G) + 10, 0))
        If (m_nextColor.r = 0) Then
            m_nextColor.G = 240
            m_nextColor.B = 10
        End If
    ElseIf (m_nextColor.G > 0) Then
        m_nextColor.G = CByte(MaxLng(CLng(m_nextColor.G) - 10, 0))
        m_nextColor.B = CByte(MaxLng(CLng(m_nextColor.B) + 10, 0))
        If (m_nextColor.G = 0) Then
            m_nextColor.B = 240
            m_nextColor.r = 10
        End If
    Else
        m_nextColor.B = CByte(MaxLng(CLng(m_nextColor.B) - 10, 0))
        m_nextColor.r = CByte(MaxLng(CLng(m_nextColor.r) + 10, 0))
        If (m_nextColor.B = 0) Then
            m_nextColor.r = 240
            m_nextColor.G = 10
        End If
    End If
End Sub
Private Sub SetRobotElementPosition(rob As Robot, pt As RoomPoint)
    rob.Element.Left = CDbl(pt.x) / ROOM_SIZE
    rob.Element.Top = CDbl(pt.y) / ROOM_SIZE
End Sub

Private Function MousePositionToRoomPoint(ByVal x As Double, ByVal y As Double) As RoomPoint 'e As MouseEventArgs
    MousePositionToRoomPoint = New_RoomPoint(Int(x * ROOM_SIZE), Int(y * ROOM_SIZE))
End Function

Sub PerformSimulationStep()
    '// Calculate a new position for each robot, update _roomCells and each
    '// Robot.Location with that information
    Dim i As Long
    Dim rob As Robot
    'If (chkParallel.IsChecked.Value) Then
    '    Parallel.ForEach(_robots, SimulateOneStep)
    'Else
        'foreach (Robot robot in _robots) SimulateOneStep(robot)
        For i = 0 To m_robots.Count - 1
            Call SimulateOneStep(m_robots.Arr(i))
        Next
    'End If
    
    '// update the on-screen position of all robots
    'for (each) (Robot robot in _robots)
    For i = 0 To m_robots.Count - 1
        rob = m_robots.Arr(i)
        Call SetRobotElementPosition(rob, rob.Location)
    Next
    '// Update statistics
    'if ((++_frameIndex % FramesPerSample) == 0) then
    '    double fps = (1000 / (double)_framesPerSecondStopwatch.ElapsedMilliseconds) * FramesPerSample
    '    txtStatus.Text = String.Format("{0} robots, {1:n1} fps", _robots.Count, fps)
    '    _framesPerSecondStopwatch.Restart()
    'End If
End Sub

Private Sub SimulateOneStep(r As Robot)
            '// Set ptR to the location of the robot in room coordinates
    Dim ptR As RoomPoint: ptR = r.Location
    Dim vectorX As Double, vectorY As Double
    Dim i As Long
    
    For i = 0 To m_robots.Count - 1
        Dim s As Robot: s = m_robots.Arr(i)
        If MRobot.IsEqual(r, s) Then
            'continue;
        Else
            Dim ptS As RoomPoint: ptS = s.Location
            Dim inverseSquareDistance As Double
            inverseSquareDistance = 1# / Square(MRobot.DistanceTo(ptR, ptS))
            Dim angle As Double: angle = MRobot.AngleTo(ptR, ptS)
            vectorX = vectorX - inverseSquareDistance * VBA.Math.Cos(angle)
            vectorY = vectorY - inverseSquareDistance * VBA.Math.Sin(angle)
        End If
    Next
    
    Dim degrees As Double: degrees = Math.Atan2(vectorY, vectorX) * 180 / Math.PI

    degrees = degrees + 22.5
    While (degrees < 0):    degrees = degrees + 360: Wend
    While (degrees >= 360): degrees = degrees - 360: Wend
    
    Dim direction As Long: direction = Int(degrees * 8 / 360)
    'Debug.Print direction
'    If ((direction = 7) Or (direction = 0) Or (direction = 1) Or (direction = 2)) Then
'        ptR.x = Math.MinLng(ptR.x + 1, ROOM_SIZE - 1)
'    ElseIf ((direction = 3) Or (direction = 4) Or (direction = 5) Or (direction = 6)) Then
'        ptR.x = Math.MaxLng(ptR.x - 1, 0)
'    End If
'    If ((direction = 0) Or (direction = 1) Or (direction = 2) Or (direction = 3)) Then
'        ptR.y = Math.MinLng(ptR.y + 1, ROOM_SIZE - 1)
'    ElseIf ((direction = 4) Or (direction = 5) Or (direction = 6) Or (direction = 7)) Then
'        ptR.y = Math.MaxLng(ptR.y - 1, 0)
'    End If
    Select Case direction
    Case 0, 1, 7 '2 wird ausgelassen
        ptR.x = Math.MinLng(ptR.x + 1, ROOM_SIZE - 1)
    Case 3, 4, 5 '6 wird ausgelassen
        ptR.x = Math.MaxLng(ptR.x - 1, 0)
    End Select
    Select Case direction
    Case 1, 2, 3 ', 0 wird ausgelassen
        ptR.y = Math.MinLng(ptR.y + 1, ROOM_SIZE - 1)
    Case 5, 6, 7 ', 4 wird ausgelassen
        ptR.y = Math.MaxLng(ptR.y - 1, 0)
    End Select
    If (((ptR.x <> r.Location.x) Or (ptR.y <> r.Location.y)) And MRobot.IsEqual(m_roomCells(ptR.x, ptR.y), NullRobot)) Then
        m_roomCells(r.Location.x, r.Location.y) = NullRobot
        m_roomCells(ptR.x, ptR.y) = r
        'Debug.Print RoomPointToString(r.Location)
        r.Location = New_RoomPoint(ptR.x, ptR.y)
        'Debug.Print RoomPointToString(r.Location)
        Call SetRobotElementPosition(r, r.Location)
    End If
End Sub

Private Sub Room_Paint()
    Room.Cls
    Dim i As Long
    For i = 0 To m_robots.Count - 1
        With m_robots.Arr(i).Element
            'object.Circle [Step] (x, y), radius, [color, start, end, aspect]
            Room.FillColor = .FillColor
            'Room.ForeColor = .FillColor
            Room.FillStyle = vbSolid
            Dim r As Double: r = .Height / 2
            Room.Circle (.Left + r, .Top + r), r, .FillColor
        End With
    Next
End Sub

Private Sub Timer1_Timer()
    recomputeAndRedraw
End Sub
