Attribute VB_Name = "Math"
Option Explicit
Public Const PI As Double = 3.14159265358979

Public Function Square(ByVal n As Double) As Double
   Square = n * n
End Function

'Public Function Max(v1, v2)
'   If v1 > v2 Then Max = v1 Else Max = v2
'End Function
'Public Function Min(v1, v2) 'byval is not necessary
'   If v1 < v2 Then Min = v1 Else Min = v2
'End Function

Public Function MaxLng(ByVal v1 As Long, ByVal v2 As Long) As Long
   If v1 > v2 Then MaxLng = v1 Else MaxLng = v2
End Function
Public Function MinLng(ByVal v1 As Long, ByVal v2 As Long)
   If v1 < v2 Then MinLng = v1 Else MinLng = v2
End Function

Public Function MaxDbl(ByVal v1 As Double, ByVal v2 As Double) As Double
   If v1 > v2 Then MaxDbl = v1 Else MaxDbl = v2
End Function
Public Function MinDbl(ByVal v1 As Double, ByVal v2 As Double) As Double
   If v1 < v2 Then MinDbl = v1 Else MinDbl = v2
End Function

Public Function Atan2(ByVal y As Double, ByVal x As Double) As Double
    If x > 0 Then        'egal ob y > 0 oder y < 0    '1. Quadrant und 4. Quadrant
        Atan2 = VBA.Math.Atn(y / x)
    ElseIf x < 0 Then
        If y > 0 Then                '2. Quadrant
            Atan2 = VBA.Math.Atn(y / x) + PI
        ElseIf y < 0 Then            '3. Quadrant
            Atan2 = VBA.Math.Atn(y / x) - PI
        Else                         'neg x-Achse
            Atan2 = PI
        End If
    Else
        If y > 0 Then                'pos y-Achse
            Atan2 = 0.5 * PI
        ElseIf y < 0 Then            'neg y-Achse
            Atan2 = -0.5 * PI
        Else                         'Nullpunkt
            Atan2 = 0#
        End If
    End If
End Function
